/* ----------------------------------------------------------------------------
 * gxinterface -- Gtk+ Extended Interface
 * Common C++ tools Header
 *
 * ----------------------------------------------------------------------------
 * copyright © 2006, 2007, 2008, 2009, 2010Jérôme BENHAÏM <benhaimjerome@gmail.com>
 *
 * ----------------------------------------------------------------------------
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * ----------------------------------------------------------------------------
 */

#ifndef interface_COMMON_H
#define interface_COMMON_H

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif
/* std C */
#include <iostream>
//#include <vector>
//#include <string>
//#include 
#ifdef ENABLE_NLS
	#include <libintl.h>
	#include <glibmm/i18n.h>
#endif
#include <gtkmm.h>
#ifdef G_OS_WIN32
	#  include <windows.h>
	#define DS ('\\')
	/* CR+LF */
	#define EOL ('\r\n')
#endif
#ifdef G_OS_LIN
	/* LF */
	#define EOL ('\n')
#endif
#ifdef G_OS_UNIX 
	/* LF */
	#define EOL ('\n')
#endif
#ifdef G_OS_OSX
	/* LF */
	#define EOL ('\n')
#endif
#ifdef G_OS_MAC
	/* CR */
	#define EOL ('\r')
#endif

#define DS ('/')
#define APPLICATION_NAME (_("interface"))
Glib::ustring guint2str(guint);
	/* WARNING if object not the same in table */
	//  C using
	//#define NB_ELEMENTS(tab) sizeof(tab)/sizeof(tab[0])
#endif /* interface_COMMON_H */

