/* ----------------------------------------------------------------------------
 * gxinterface -- Gtk+ Extended Interface
 * Module and module manager source
 *
 * ----------------------------------------------------------------------------
 * copyright © 2006, 2007, 2008, 2009, 2010 Jérôme BENHAÏM <benhaimjerome@gmail.com>
 *
 * ----------------------------------------------------------------------------
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * ----------------------------------------------------------------------------
 */

#ifndef gemod_CC
    #define gemod_CC
	/*#include <gtkmm>*/
	/* app */
	#include "debug.h"
    #include "common.h"
	#include "gemod.h"
/*
 ***** Gx_module *****
 */
/* gx as ui, ex: for Gemod as Gx module manager, first loaded function are in derived class */
Gx_module::Gx_module(Glib::ustring filename){ 
	LOG_IN();
	//if ( exist ){
		load(filename,0);
	//}else{
		//throw filenotexist(filename, __PRETTY_FUNCTION__)
	//};
	LOG_OUT();
};
int Gx_module::load(Glib::ustring filename, guint index){
	/* extract filename */
	extractPath(filename);
	
	if ( mod.extpath.ext == "glade" ||  mod.extpath.ext == "ui" ||  mod.extpath.ext == "xml" ){
		set_refxml(filename);
		mod.index=index;
		return 1;
	}else if ( mod.extpath.ext == "la" ){
		mod.index=index;
		std::cout << filename << std::endl;
		module = new Glib::Module(filename);
		if (!module) {
       		std::cout << "Error no module: " << module->get_last_error() << std::endl;
			return 0;
		}else{
			std::cout << "Name of the plugin: " << module->get_name() << std::endl;
			if( module->get_symbol( "LoadPlug", (void*&) module_func ) ){
           		std::cout << "Function exist" << std::endl;
				refXml=module_func(mod.extpath.path+mod.extpath.name+".ui",index);
				return 1;
			}else{
           		std::cout << "Error no function: " << module->get_last_error() << std::endl;
				return 0;
			}
  		 }
	}else{
		std::cout << "error bad extenstion file accept .ui or .glade or .xml for UI and .la for module" << std::endl;
		return 0;
	};
};
void Gx_module::extractPath(Glib::ustring filename){
	LOG_IN();
	/* extract to extpath ( extention, filename, path ,name ,file ) */
	gint start, end;
	mod.extpath.file=filename;
	start = filename.find_last_of(DS);
	mod.extpath.filename = filename.substr(start + 1, filename.length() - (start+1) );
	mod.extpath.path = filename.substr(0, start+1 );
	end = filename.find_last_of(".");
	mod.extpath.ext = filename.substr( end+1, filename.length() );
	mod.extpath.name = filename.substr(start+1, mod.extpath.filename.length() - mod.extpath.ext.length() -1 );
	std::cout << " mod.extpath.name " << mod.extpath.name << std::endl;
	std::cout << " mod.extpath.ext " << mod.extpath.ext << std::endl;
	std::cout << " mod.extpath.path " << mod.extpath.path << std::endl;
	std::cout << " mod.extpath.filename " << mod.extpath.filename << std::endl;
	std::cout << " mod.extpath.file " << mod.extpath.file << std::endl;
	LOG_OUT();
};
/* gx module as .la */
Gx_module::Gx_module(Glib::ustring filename, guint index) {
	LOG_IN();
	load(filename,index);
	LOG_OUT();
};
/* array of gx_module */
Gx_module::Gx_module() {
	LOG_IN();
	LOG_OUT();
};

Gx_module::~Gx_module(){ 
	LOG_IN();
	if ( mod.extpath.ext == "la" ){
		delete module;
	};
	LOG_OUT();
};
gboolean Gx_module::set_refxml(Glib::ustring filename)	{ LOG_IN();
	#ifdef GLIBMM_EXCEPTIONS_ENABLED
		try { refXml = Gtk::Builder::create_from_file(filename); 
			return 1;
		}catch (const Glib::Error & ex){
			std::cerr << ex.what() << std::endl;
			return 0;
		};
	#else
		/*auto_ptr<Gnome::Glade::XmlError> error;
		refXml = Gnome::Glade::Xml::create(name, "", "", error);
		if(error.get()){ std::cerr << error->what() << std::endl; exit;	}*/
	#endif
	LOG_OUT();
};		

void Gx_module::set_mod( Glib::ustring filename, guint index ) 	{ LOG_IN();
		load(filename,index);
LOG_OUT(); };	

void Gx_module::set_module_name( Glib::ustring name ) 	{ LOG_IN();
		mod.extpath.name = name;
LOG_OUT(); };	

void Gx_module::unset_mod()	{ LOG_IN(); 
	/*dettach_signals();
	if ( mod.extpath.ext == "la" ){
		delete module;
	};*/
LOG_OUT(); };

void Gx_module::attach_signals(){};
void Gx_module::dettach_signals(){};

std::string Gx_module::get_name(){	return mod.extpath.name ; };
std::string Gx_module::get_file(){	return mod.extpath.file ; };
std::string Gx_module::get_type(){	return mod.type ; };
std::string Gx_module::get_cat(){	return mod.cat ; };
std::string Gx_module::get_desc(){	return mod.desc ; };
std::string Gx_module::get_ext(){	return mod.extpath.ext ; };
std::string Gx_module::get_filename(){	return mod.extpath.filename ; };
std::string Gx_module::get_path(){	return mod.extpath.path ; };
Glib::RefPtr<Gtk::Builder> Gx_module::get_refxml(){	return refXml ; };
/*
 * Gemod
 */
Glib::ustring Gemod::get_module_name(guint index){ return modules[index].get_name(); };

gint Gemod::get_module_index(Glib::ustring sfile){
	for (guint i = 0 ; i < nb_mod; i++){
		if ( modules[i].get_file() == sfile ){ return i; };
	};
	/* not found */
	return -1;	
};	
	/* get root widget by module index name must be vbox_main*/ 
Gtk::VBox*	Gemod::get_module_root(guint index)	{ return modules[index].get_module(); };
	/* get root widget by module name */
Gtk::VBox*	Gemod::get_module_root(Glib::ustring module_name){ 
			return modules[get_module_index(module_name)].get_module();
};
   /*  get root window */
Gtk::Window* Gemod::get_main() { return get_gwidget<Gtk::Window>("window_main"); };	

/* attache les signaux sur tous les elements */
void Gemod::attach_signals(){LOG_IN();	
	(get_gwidget<Gtk::MenuItem>("menu_add_module"))->signal_activate().connect(sigc::mem_fun(*this, &Gemod::on_menu_add_module_event));		
	(get_gwidget<Gtk::MenuItem>("menu_del_module"))->signal_activate().connect(sigc::mem_fun(*this, &Gemod::on_menu_del_module_event));		
LOG_OUT();};	
void Gemod::dettach_signals(){LOG_IN(); LOG_OUT();};
/* Events */
void Gemod::on_menu_add_module_event(){ LOG_IN();
	add_module( MODULE_UI_DIR"libgxsynth-0.0.1.la");
LOG_OUT(); };		
void Gemod::on_menu_del_module_event(){ LOG_IN();
	del_module("data/ui/dx7.glade");
LOG_OUT(); };

gboolean load(Glib::ustring module_name){ };

gboolean Gemod::add_module(Glib::ustring module_name){
	LOG_IN();
	if (nb_mod >= 0 && nb_mod <= max_modules ){
		/* */
		modules[nb_mod].set_mod(module_name,nb_mod);
		gint nb = get_module_index(module_name);
		if  ( nb != -1 ){
			modules[nb_mod].set_module_name( modules[nb_mod].get_name() + " " + guint2str(nb+1) );
		};
		(get_gwidget<Gtk::Notebook>("notebook_main"))->pages().push_back(Gtk::Notebook_Helpers::TabElem(*(get_module_root(nb_mod)), modules[nb_mod].get_name()) );
		// attacher les signaux
		add_menu("menu_modules", modules[nb_mod].get_name());
		nb_mod++;
		LOG_OUT(); return 1;
	};
	LOG_OUT(); return 0;
};

gboolean Gemod::del_module(Glib::ustring module_name){ 
	LOG_IN();
		if ( nb_mod > 0 && get_module_index(module_name) != -1 ){
			(get_gwidget<Gtk::Notebook>("notebook_main"))->pages().remove( *(get_module_root(get_module_index(module_name)))  );
			//modules[get_module_index(module_name)].unset_mod();
						//del_menu(module_name);					
			nb_mod--;
			LOG_OUT(); return 1;
		}else{
			std::cout << _("Le module n'existe pas") << std::endl;
			LOG_OUT(); return 0;
		};
LOG_OUT();
};

/* Menu construction*/
/*Gtk::MenuItem* Gemod::create_menuitem(Glib::ustring name) { LOG_IN();
	Gtk::Menu_Helpers::MenuList::iterator iter = (get_menu("menu_modules"))->items().end();
	(get_menu("menu_modules"))->items().insert(iter,Gtk::Menu_Helpers::MenuElem(name) );
	(get_menuitem("Add"))->set_submenu( *(create_submenu()) );
LOG_OUT(); };*/

Gtk::Menu* Gemod::create_submenu(Glib::ustring* menu) { 
	LOG_IN(); 
	Gtk::Menu * submenu;
	submenu = manage (new Gtk::Menu);
    guint length = sizeof(menu)/sizeof(Glib::ustring);
	for ( guint i=0 ; i <= length ; i++ ){
		submenu->items().push_back (Gtk::Menu_Helpers::MenuElem(menu[i]));
	};
	LOG_OUT();
	return (Gtk::Menu *) submenu;
};

Gtk::MenuItem * Gemod::get_menu_dyn(Glib::ustring menu){
	for ( Gtk::Menu_Helpers::MenuList::iterator iter = (get_gwidget<Gtk::Menu>("menu_modules"))->items().begin() ; iter != (get_gwidget<Gtk::Menu>("menu_modules"))->items().end(); iter++) {
		if ((*iter).get_label() == menu ){
			return (Gtk::MenuItem*) &(*iter) ;
		};
	 }; 
}

gboolean Gemod::add_menu(Glib::ustring menu_name, Glib::ustring module_name){ 
	LOG_IN(); 
	if (nb_mod >= 0){
		Gtk::Menu_Helpers::MenuList::iterator iter = (get_gwidget<Gtk::Menu>(menu_name))->items().end();
		(get_gwidget<Gtk::Menu>(menu_name))->items().insert(iter,Gtk::Menu_Helpers::MenuElem(module_name) );
		Glib::ustring menus[2] = {_("activé"),_("désactivé")};
		(get_menu_dyn(module_name))->set_submenu( *(create_submenu(menus)) );
	}else{
		std::cout << "echec menu" << std::endl;
		LOG_OUT(); return 0;
	};
LOG_OUT(); };

gboolean Gemod::del_menu(Glib::ustring module_name){
	LOG_IN();
	try {
		if ( nb_mod > 0 ){
			Gtk::Menu_Helpers::MenuList::iterator iter_end = (get_gwidget<Gtk::Menu>("menu_modules"))->items().end();
			for ( Gtk::Menu_Helpers::MenuList::iterator iter = (get_gwidget<Gtk::Menu>("menu_modules"))->items().begin() ; iter != iter_end ; iter++) {
				if ((*iter).get_label() == module_name ){
					std::cout << (*iter).get_label() << std::endl;
					(get_gwidget<Gtk::Menu>("menu_modules"))->items().remove(*(iter));
				};
			};
			//(get_menu("menu_modules"))->items().insert((get_menu("menu_modules"))->items().end(),Gtk::Menu_Helpers::SeparatorElem());
			LOG_OUT (); return 1;
		}else{
			LOG_OUT (); return 0;
		};
	}catch (const Glib::Exception & ex){
			std::cerr << ex.what() << std::endl; 
	};
	LOG_OUT(); 
};		

/* gemod as base gestionnaire not a module */ 
Gemod::Gemod(Glib::ustring module_name) : Gx_module(module_name){
	LOG_IN();
	nb_mod=0;
	max_modules=5;
	modules=new Gx_module[max_modules];
	attach_signals();
LOG_OUT(); 
};
/* gemod as module */
Gemod::Gemod(Glib::ustring module_name, guint index) : Gx_module(module_name,index){
	LOG_IN();
	nb_mod=0;
	max_modules=5;
	modules=new Gx_module[max_modules];
	attach_signals();
LOG_OUT(); 
};
/* gemod as module specifie number of module */
Gemod::Gemod(Glib::ustring module_name, guint index, guint max_mod) : Gx_module(module_name, index){ 
	LOG_IN();
	nb_mod=0;
	max_modules=max_mod;
	modules=new Gx_module[max_modules];
	attach_signals();
LOG_OUT(); 
};
/*Gemod::Gemod(){ };		*/
Gemod::~Gemod(){ };

#endif  /* gemod_CC */
