/* ----------------------------------------------------------------------------
 * gxinterface -- Gtk+ Extended Interface
 * gxinterface source
 * ----------------------------------------------------------------------------
 * copyright © 2006, 2007, 2008, 2009, 2010 Jérôme BENHAÏM <benhaimjerome@gmail.com>
 *
 * ----------------------------------------------------------------------------
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * ----------------------------------------------------------------------------
 */
#include "gxinterface.h"
/* class Ge_interface */
Gx_interface::Gx_interface(gint argc, gchar *argv[]) { LOG_IN();
	/* I/O init */
	Gio::init();
	/* gthread init */
	if (!g_thread_supported()){
		g_thread_init(NULL);
	};
	/* init of error code */
	error = NULL;
	/* Gtk init */
	Gtk::Main kit(argc, argv);	
	/* analyse of command line parameters */
	analyseparam(argc, argv);
	
	//setup_log_handlers ();	
	
	module_manager=new Gemod(iname);
	/* interface init */
	g_set_application_name(iname.c_str());
	gtk_window_set_default_icon_name (iname.c_str());
	
	if(module_manager){ kit.run(*(module_manager->get_main())); }
	
	LOG_OUT();	
};

Gx_interface::~Gx_interface(){ LOG_IN(); delete module_manager; LOG_OUT(); };

guint Gx_interface::analyseparam(gint argc, gchar *argv[]) { LOG_IN();
	guint i;
	/* TODO: use C++ getopts */
	/* analyse argument of command line */ 
	for ( i = 1; i <= argc; i++) {
		if ( (argv[i] != NULL) && (Glib::ustring(argv[i]) == "-f")
		  && (argv[i+1] != NULL) && (Glib::ustring(argv[i+1]) != "") ){  // -f and name as argument
			FILE *file = fopen(argv[i+1],"r");
			if ( file == NULL) {						// try open fil
				iname=UI_FILE;
				std::cout << _("Le fichier ")<<argv[i+1]<<_(" n'existe pas") << std::endl;
				std::cout << _("Chargement du fichier par defaut : ") << iname << std::endl;
			}else{
			   std::cout << _("Chargement du fichier d'interface : ")<<argv[i+1]<<" ."<<std::endl;				
			   iname=Glib::ustring(argv[i+1]);
			};
		    fclose(file);
		};
	};
	if (iname == ""){
		iname=UI_FILE;
		std::cout << _("Aucun fichier specifié. ") << std::endl;
		std::cout << _("Chargement du fichier : ") << iname << std::endl;
		FILE *file = fopen( iname.c_str() ,"r");
		if ( file == NULL) {						// try open fil
			std::cout << _("Le fichier ")<< iname <<_(" n'existe pas") << std::endl;
			iname=UI_FILE;
			std::cout << _("Chargement du fichier par defaut : ") << iname << std::endl;
			FILE *file = fopen(iname.c_str() ,"r");
			fclose(file);
		}else{
			//std::cout << "argv "<<i<<" : "<< argv[i-1]<<" ."<< std::endl;
			fclose(file);
		};
	};
	LOG_OUT();
	return 0;
};

Glib::ustring Gx_interface::get_itype(){ LOG_IN(); return itype; LOG_OUT(); };

