/* ----------------------------------------------------------------------------
 * Dx7interface.h -- DX7 Graphic interface
 * dx7 interface Headers                                             header
 * ----------------------------------------------------------------------------
 * copyright © 2006, 2007, 2008, 2009, 2010  Jérôme BENHAÏM <benhaimjerome@gmail.com>,
 *
 * ----------------------------------------------------------------------------
 * This program is free software ; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation ;
 * either version 2 of the License, or (at your option) 
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY ; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * ----------------------------------------------------------------------------
 */

#ifndef Dx7interface_H
    #define Dx7interface_H
    /* sys */ 
	/* app */
	#include <GxInterface/debug.h>
    #include <GxInterface/common.h>
    /* gnome */
	#include <gtkmm.h>
	/* module */
    #include <GxInterface/gemod.h>
    /* sysex */
	#include "dx7sysex.h"
	// Liste des Class	
	/* class générique */
class Dx7interface : public Gx_module {
	private:
		struct St_dx7sysex_128 * orgin_sysex;
		struct St_dx7sysex_128 * modif_sysex;
		
		// Fonctions d'evenements
		//origin.sound[nb].op2.r1.val=12;
		//origin.sound[nb].voicename;
		void on_mute_op_event();		
		void on_op1_r1_change_event();
		
	protected:
		void attach_signals();
	public:		
		Dx7interface(Glib::ustring,int);
		~Dx7interface();
		 //friend class Gx_module;

};
static int init(Glib::ustring,int);

#endif /* Dx7interface_H */
