/* ----------------------------------------------------------------------------
 * sysex_edit.cc -- DX7 Graphic interface
 * Modules editeur de sysex                                             source
 * ----------------------------------------------------------------------------
 * copyright (c) 2006 Jérôme BENHAÏM <benhaimjerome@gmail.com>, 
 *					  Jean-Michel THIEMONGE
 *
 * ----------------------------------------------------------------------------
 * This program is free software ; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation ;
 * either version 2 of the License, or (at your option) 
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY ; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * ----------------------------------------------------------------------------
 */

#ifndef sysex_edit_C
	#include "sysex_edit.h" 
void SysexEdit::dettach_signals(){	 LOG_IN();
	
	LOG_OUT(); 
};

void SysexEdit::attach_signals(){	 LOG_IN();
	//(je recupere l'object)->sur le signal de l'evenement.je connecte( le signal de ( la fonction ));
	// (i get the ui object)->on_signal_of_event.I_connect(the_signal_of(the_function));
	/* generale  */
	(get_gwidget<Gtk::FileChooserButton>("bank_select"))->signal_selection_changed().connect(
	     sigc::mem_fun(*this, &SysexEdit::on_bank_select));
	(get_gwidget<Gtk::TreeView>("treeview_bank"))->signal_row_activated().connect(
	     sigc::mem_fun(*this, &SysexEdit::on_treeview_row_activated));
	(get_gwidget<Gtk::TreeView>("treeview_bank"))->signal_cursor_changed().connect(
	     sigc::mem_fun(*this, &SysexEdit::on_treeview_row_clicked));

	/* algo */
	(get_gwidget<Gtk::SpinButton>("algo"))->signal_value_changed().connect(
	 	sigc::mem_fun(*this, &SysexEdit::on_algo_event));	
	(get_gwidget<Gtk::SpinButton>("feedback"))->signal_value_changed().connect(
	    sigc::mem_fun(*this, &SysexEdit::on_feedback_event));
	(get_gwidget<Gtk::ComboBox>("note_transpose"))->signal_changed().connect(
         sigc::mem_fun(*this, &SysexEdit::on_transpose_event));	
	(get_gwidget<Gtk::SpinButton>("octv_transpose"))->signal_value_changed().connect(
	    sigc::mem_fun(*this, &SysexEdit::on_transpose_event));
	(get_gwidget<Gtk::CheckButton>("oks"))->signal_toggled().connect(
        sigc::mem_fun(*this, &SysexEdit::on_oks_event));

	/* lfo */
	(get_gwidget<Gtk::ComboBox>("lfo_wav"))->signal_changed().connect(
  		sigc::mem_fun(*this, &SysexEdit::on_lfo_wav_event));
	(get_gwidget<Gtk::CheckButton>("lfo_sync"))->signal_toggled().connect(
	    sigc::mem_fun(*this, &SysexEdit::on_lfo_sync_event));
	(get_gwidget<Gtk::SpinButton>("speed"))->signal_value_changed().connect(
        sigc::mem_fun(*this, &SysexEdit::on_speed_event));
	(get_gwidget<Gtk::SpinButton>("delay"))->signal_value_changed().connect(
        sigc::mem_fun(*this, &SysexEdit::on_delay_event));
	(get_gwidget<Gtk::SpinButton>("pmd"))->signal_value_changed().connect(
        sigc::mem_fun(*this, &SysexEdit::on_pmd_event));
	(get_gwidget<Gtk::SpinButton>("amd"))->signal_value_changed().connect(
        sigc::mem_fun(*this, &SysexEdit::on_amd_event));
	/* lfo modulation */
	(get_gwidget<Gtk::HScale>("pms"))->signal_value_changed().connect(
		sigc::mem_fun(*this, &SysexEdit::on_pms_event));

	/* pitch eg*/
	(get_gwidget<Gtk::SpinButton>("pitch_rt1"))->signal_value_changed().connect(
        sigc::mem_fun(*this, &SysexEdit::on_pitch_rt1_event));
	(get_gwidget<Gtk::SpinButton>("pitch_rt2"))->signal_value_changed().connect(
        sigc::mem_fun(*this, &SysexEdit::on_pitch_rt2_event));
	(get_gwidget<Gtk::SpinButton>("pitch_rt3"))->signal_value_changed().connect(
        sigc::mem_fun(*this, &SysexEdit::on_pitch_rt3_event));
	(get_gwidget<Gtk::SpinButton>("pitch_rt4"))->signal_value_changed().connect(
        sigc::mem_fun(*this, &SysexEdit::on_pitch_rt4_event));
	(get_gwidget<Gtk::SpinButton>("pitch_lvl1"))->signal_value_changed().connect(
        sigc::mem_fun(*this, &SysexEdit::on_pitch_lvl1_event));
	(get_gwidget<Gtk::SpinButton>("pitch_lvl2"))->signal_value_changed().connect(
        sigc::mem_fun(*this, &SysexEdit::on_pitch_lvl2_event));
	(get_gwidget<Gtk::SpinButton>("pitch_lvl3"))->signal_value_changed().connect(
        sigc::mem_fun(*this, &SysexEdit::on_pitch_lvl3_event));
	(get_gwidget<Gtk::SpinButton>("pitch_lvl4"))->signal_value_changed().connect(
        sigc::mem_fun(*this, &SysexEdit::on_pitch_lvl4_event));	

	/* operateurs */
	/* op1 */
	/*op1 freq*/
	(get_gwidget<Gtk::ComboBox>("freq_mode_op1"))->signal_changed().connect(
  		sigc::mem_fun(*this, &SysexEdit::on_freq_mode_op1_event));
	(get_gwidget<Gtk::SpinButton>("freq_coarse_op1"))->signal_value_changed().connect(
        sigc::mem_fun(*this, &SysexEdit::on_freq_coarse_op1_event));
	(get_gwidget<Gtk::SpinButton>("freq_fine_op1"))->signal_value_changed().connect(
  		sigc::mem_fun(*this, &SysexEdit::on_freq_fine_op1_event));
	(get_gwidget<Gtk::HScale>("dtun_op1"))->signal_value_changed().connect(
        sigc::mem_fun(*this, &SysexEdit::on_dtun_op1_event));
	/*op1 drawingarea*/
	/*op1 eg*/	
		(get_gwidget<Gtk::SpinButton>("eg_rt1_op1"))->signal_value_changed().connect(
        sigc::mem_fun(*this, &SysexEdit::on_eg_rt1_op1_event));
	(get_gwidget<Gtk::SpinButton>("eg_rt2_op1"))->signal_value_changed().connect(
        sigc::mem_fun(*this, &SysexEdit::on_eg_rt2_op1_event));
	(get_gwidget<Gtk::SpinButton>("eg_rt3_op1"))->signal_value_changed().connect(
        sigc::mem_fun(*this, &SysexEdit::on_eg_rt3_op1_event));
	(get_gwidget<Gtk::SpinButton>("eg_rt4_op1"))->signal_value_changed().connect(
        sigc::mem_fun(*this, &SysexEdit::on_eg_rt4_op1_event));
	(get_gwidget<Gtk::SpinButton>("eg_lvl1_op1"))->signal_value_changed().connect(
        sigc::mem_fun(*this, &SysexEdit::on_eg_lvl1_op1_event));
	(get_gwidget<Gtk::SpinButton>("eg_lvl2_op1"))->signal_value_changed().connect(
        sigc::mem_fun(*this, &SysexEdit::on_eg_lvl2_op1_event));
	(get_gwidget<Gtk::SpinButton>("eg_lvl3_op1"))->signal_value_changed().connect(
        sigc::mem_fun(*this, &SysexEdit::on_eg_lvl3_op1_event));
	(get_gwidget<Gtk::SpinButton>("eg_lvl4_op1"))->signal_value_changed().connect(
        sigc::mem_fun(*this, &SysexEdit::on_eg_lvl4_op1_event));

	/*op1 volume*/
	(get_gwidget<Gtk::HScale>("krs_op1"))->signal_value_changed().connect(
		sigc::mem_fun(*this, &SysexEdit::on_krs_op1_event));
	(get_gwidget<Gtk::HScale>("kvs_op1"))->signal_value_changed().connect(
		sigc::mem_fun(*this, &SysexEdit::on_kvs_op1_event));
	(get_gwidget<Gtk::SpinButton>("lvl_op1"))->signal_value_changed().connect(
        sigc::mem_fun(*this, &SysexEdit::on_lvl_op1_event));	
	(get_gwidget<Gtk::ToggleButton>("mute_op1"))->signal_toggled().connect(
        sigc::mem_fun(*this, &SysexEdit::on_mute_op1_event));
	
	/* op2 */
	

	/* op3 */
	

	/* op4 */
	

	/* op5 */
	

	/* op6 */
	
	
	//get_gwidget<gtk::algo>("algo_select")->click_on().connect(sigc::mrmçfunc(*this,&sysexedit::on_change_algo_event))
	LOG_OUT(); 
};
void SysexEdit::set_voice(St_dx7sysex_1* sound){
	/* set value in each widget from modif */
	/* general */
	
	/* ALGO */
	(get_gwidget<Gtk::SpinButton>("algo"))->set_value(sound->algo.algo.val);
	(get_gwidget<Gtk::SpinButton>("feedback"))->set_value(sound->algo.feedback.val);
		/*	[0-11] + (([1-5]-1)*12)	*/
	std::cout << guint2str(sound->algo.transpose.val) << std::endl;
	(get_gwidget<Gtk::ComboBox>("note_transpose"))->set_active(sound->algo.transpose.val % 12);
	(get_gwidget<Gtk::SpinButton>("octv_transpose"))->set_value( (sound->algo.transpose.val / 12)+1 );

	(get_gwidget<Gtk::CheckButton>("oks"))->set_active(sound->algo.oks.val);	
	
	/* LFO */
	(get_gwidget<Gtk::ComboBox>("lfo_wav"))->set_active(sound->lfo.wave.val);
    (get_gwidget<Gtk::CheckButton>("lfo_sync"))->set_active(sound->lfo.sync.val);
	(get_gwidget<Gtk::SpinButton>("speed"))->set_value(sound->lfo.speed.val);
	(get_gwidget<Gtk::SpinButton>("delay"))->set_value(sound->lfo.delay.val);
	(get_gwidget<Gtk::SpinButton>("pmd"))->set_value(sound->lfo.pmd.val);
	(get_gwidget<Gtk::SpinButton>("amd"))->set_value(sound->lfo.amd.val);
	/* LFO modulation */
	(get_gwidget<Gtk::HScale>("pms"))->set_value(sound->lfo.pms.val);
	/* PITCH EG */
	for ( guint8 k = 0; k < 4 ; k++ ){
		(get_gwidget<Gtk::SpinButton>("pitch_rt"+guint2str(k+1)))->set_value(sound->pitch.rt[k].val);
	};
	for ( guint8 k = 0; k < 4 ; k++ ){
		(get_gwidget<Gtk::SpinButton>("pitch_lvl"+guint2str(k+1)))->set_value(sound->pitch.lvl[k].val);
	};
	
	/*if(sound->op[j].freq_coarse.val == 0 ){
			(get_gwidget<Gtk::ToggleButton>("op"+guint2str(j+1)+"_mute"))->set_active();
	};*/


	/* OPERATEUR j */
	for (guint8 j=0;j<6;j++){
	/* OP[J] EG RT[k] */
		for ( guint8 k = 0; k < 4 ; k++ ){
			(get_gwidget<Gtk::SpinButton>("eg_rt"+guint2str(k+1)+"_op"+guint2str(j+1)))->set_value(sound->op[j].eg_rt[k].val);
		};
	/* OP[J] EG LVL[k] */
		for ( guint8 k = 0; k < 4 ; k++  ){
			(get_gwidget<Gtk::SpinButton>("eg_lvl"+guint2str(k+1)+"_op"+guint2str(j+1)))->set_value(sound->op[j].eg_lvl[k].val);
		};
	/* KLS */
		(get_gwidget<Gtk::SpinButton>("kls_lft_dpth_op"+guint2str(j+1)))->set_value(sound->op[j].kls.lft_dpth.val);
		(get_gwidget<Gtk::SpinButton>("kls_rght_dpth_op"+guint2str(j+1)))->set_value(sound->op[j].kls.rght_curve.val);
		/* combo + op[i].note_brk_pt + spin op[i].octv_brk_pt 
			(get_gwidget<Gtk::SpinButton>("op"+guint2str(j+1)+"_kls_brk_pt"))->set_value(sound->->op[j].kls.brk_pt.val);
		*/
		/* combox */
		//(get_gwidget<Gtk::SpinButton>("kls_lft_curve_op"+guint2str(j+1)))->set_value(sound->->op[j].kls.lft_curve.val);
		//(get_gwidget<Gtk::SpinButton>("kls_rght_curve_op"+guint2str(j+1)))->set_value(sound->->op[j].kls.rght_curve.val);
	/* DTUN */
		(get_gwidget<Gtk::HScale>("dtun_op"+guint2str(j+1)))->set_value(sound->op[j].dtun.val);
	/*  KRS */
		(get_gwidget<Gtk::HScale>("krs_op"+guint2str(j+1)))->set_value(sound->op[j].krs.val);
	/*	KVS */
		(get_gwidget<Gtk::HScale>("kvs_op"+guint2str(j+1)))->set_value(sound->op[j].kvs.val);
	/* AMS */
		(get_gwidget<Gtk::VScale>("ams_op"+guint2str(j+1)))->set_value(sound->op[j].ams.val);
	/* LVL */
		(get_gwidget<Gtk::SpinButton>("lvl_op"+guint2str(j+1)))->set_value(sound->op[j].lvl.val);
	/* FREQ_MOD */
		(get_gwidget<Gtk::ComboBox>("freq_mode_op"+guint2str(j+1)))->set_active(sound->op[j].freq_mode.val);
	/* COARSE */
		(get_gwidget<Gtk::SpinButton>("freq_coarse_op"+guint2str(j+1)))->set_value(sound->op[j].freq_coarse.val);
	/* FINE */
		(get_gwidget<Gtk::SpinButton>("freq_fine_op"+guint2str(j+1)))->set_value(sound->op[j].freq_fine.val);		
	};
};

/*ALGO*/	
void SysexEdit::on_algo_event() {	LOG_IN();
	msg[3]=0x01;
	msg[4]=0x06;
	msg[5]=(get_gwidget<Gtk::SpinButton>("algo"))->get_value()-1;
	get_gwidget<Gtk::Image>("image_algo")->set(IMAGE_DIR"/algo"+guint2str(msg[5]+1)+".png");
	send_midi();
	LOG_OUT();
};

void SysexEdit::on_feedback_event() {	LOG_IN();
	msg[3]=0x01;
	msg[4]=0x07;
	msg[5]=(get_gwidget<Gtk::SpinButton>("feedback"))->get_value();
	send_midi();
	LOG_OUT();
};
	
void SysexEdit::on_transpose_event() {	LOG_IN();
	msg[3]=0x01;
	msg[4]=0x10;
	msg[5]=(get_gwidget<Gtk::ComboBox>("note_transpose"))->get_active_row_number()
		  +((get_gwidget<Gtk::SpinButton>("octv_transpose"))->get_value()-1)*12;
	send_midi();
	
	std::cout << guint2str((get_gwidget<Gtk::ComboBox>("note_transpose"))->get_active_row_number()) 
			  << " " 
		      << guint2str(((get_gwidget<Gtk::SpinButton>("octv_transpose"))->get_value()-1)) 
			  << " "
			  << guint2str((get_gwidget<Gtk::ComboBox>("note_transpose"))->get_active_row_number()
		  +((get_gwidget<Gtk::SpinButton>("octv_transpose"))->get_value()-1)*12)
	<< std::endl;
	
	LOG_OUT();
};	

void SysexEdit::on_oks_event() {	LOG_IN();
	msg[3]=0x01;
	msg[4]=0x08;
    if ( (get_gwidget<Gtk::CheckButton>("oks"))->get_active() ) {
	    msg[5]=0x01;
    }else{
	    msg[5]=0x00;
	}
	send_midi();		
	LOG_OUT();
};

/*LFO*/

void SysexEdit::on_lfo_wav_event() {	LOG_IN();
	/* lfo wave form image */
	Glib::ustring name;
    (*(get_gwidget<Gtk::ComboBox>("lfo_wav"))->get_active())->get_value(0,name) ;
	get_gwidget<Gtk::Image>("image_lfo")->set(IMAGE_DIR"/"+name+".png");
	
	msg[3]=0x01;
	msg[4]=0x0E;
	msg[5]=(get_gwidget<Gtk::ComboBox>("lfo_wav"))->get_active_row_number();	
	send_midi();
	LOG_OUT();
};	

void SysexEdit::on_lfo_sync_event() {	LOG_IN();
	msg[3]=0x01;
	msg[4]=0x0D;
    if ( (get_gwidget<Gtk::CheckButton>("lfo_sync"))->get_active() ) {
	    msg[5]=0x01;
    }else{
	    msg[5]=0x00;
	}
	send_midi();		
	LOG_OUT();
};

void SysexEdit::on_speed_event() {	LOG_IN();
	msg[3]=0x01;
	msg[4]=0x09;
	msg[5]=(get_gwidget<Gtk::SpinButton>("speed"))->get_value();
	send_midi();
	LOG_OUT();
};

void SysexEdit::on_delay_event() {	LOG_IN();
	msg[3]=0x01;
	msg[4]=0x0A;
	msg[5]=(get_gwidget<Gtk::SpinButton>("delay"))->get_value();
	send_midi();
	LOG_OUT();
};

void SysexEdit::on_pmd_event() {	LOG_IN();
	msg[3]=0x01;
	msg[4]=0x0B;
	msg[5]=(get_gwidget<Gtk::SpinButton>("pmd"))->get_value();
	send_midi();
	LOG_OUT();
};

void SysexEdit::on_amd_event() {	LOG_IN();
	msg[3]=0x01;
	msg[4]=0x0C;
	msg[5]=(get_gwidget<Gtk::SpinButton>("amd"))->get_value();
	send_midi();
	LOG_OUT();
};

/*LFO modulation*/

void SysexEdit::on_pms_event() {	LOG_IN();
	msg[3]=0x01;
	msg[4]=0x0F;
	msg[5]=(get_gwidget<Gtk::HScale>("pms"))->get_value();
	send_midi();
	LOG_OUT();
};

/* pitch eg*/

void SysexEdit::on_pitch_rt1_event() {	LOG_IN();
	msg[3]=0x00;
	msg[4]=0x7E;
	msg[5]=(get_gwidget<Gtk::SpinButton>("pitch_rt1"))->get_value();
	send_midi();
	LOG_OUT();
};

void SysexEdit::on_pitch_rt2_event() {	LOG_IN();
	msg[3]=0x00;
	msg[4]=0x7F;
	msg[5]=(get_gwidget<Gtk::SpinButton>("pitch_rt2"))->get_value();
	send_midi();
	LOG_OUT();
};

void SysexEdit::on_pitch_rt3_event() {	LOG_IN();
	msg[3]=0x01;
	msg[4]=0x00;
	msg[5]=(get_gwidget<Gtk::SpinButton>("pitch_rt3"))->get_value();
	send_midi();
	LOG_OUT();
};

void SysexEdit::on_pitch_rt4_event() {	LOG_IN();
	msg[3]=0x01;
	msg[4]=0x01;
	msg[5]=(get_gwidget<Gtk::SpinButton>("pitch_rt4"))->get_value();
	send_midi();
	LOG_OUT();
};

void SysexEdit::on_pitch_lvl1_event() {	LOG_IN();
	msg[3]=0x01;
	msg[4]=0x02;
	msg[5]=(get_gwidget<Gtk::SpinButton>("pitch_lvl1"))->get_value();
	send_midi();
	LOG_OUT();
};

void SysexEdit::on_pitch_lvl2_event() {	LOG_IN();
	msg[3]=0x01;
	msg[4]=0x03;
	msg[5]=(get_gwidget<Gtk::SpinButton>("pitch_lvl2"))->get_value();
	send_midi();
	LOG_OUT();
};

void SysexEdit::on_pitch_lvl3_event() {	LOG_IN();
	msg[3]=0x01;
	msg[4]=0x04;
	msg[5]=(get_gwidget<Gtk::SpinButton>("pitch_lvl3"))->get_value();
	send_midi();
	LOG_OUT();
};

void SysexEdit::on_pitch_lvl4_event() {	LOG_IN();
	msg[3]=0x01;
	msg[4]=0x05;
	msg[5]=(get_gwidget<Gtk::SpinButton>("pitch_lvl4"))->get_value();
	send_midi();
	LOG_OUT();
};

/*OP1*/

/*OP1 freq*/
void SysexEdit::on_freq_mode_op1_event() {	LOG_IN();
	msg[3]=0x00;
	msg[4]=0x7A;
	msg[5]=(get_gwidget<Gtk::ComboBox>("freq_mode_op1"))->get_active_row_number();	
	send_midi();
	LOG_OUT();
};	

void SysexEdit::on_freq_coarse_op1_event() {	LOG_IN();
	msg[3]=0x00;
	msg[4]=0x7B;
	msg[5]=(get_gwidget<Gtk::SpinButton>("freq_coarse_op1"))->get_value();
	send_midi();
	LOG_OUT();
};

void SysexEdit::on_freq_fine_op1_event() {	LOG_IN();
	msg[3]=0x00;
	msg[4]=0x7C;
	msg[5]=(get_gwidget<Gtk::SpinButton>("freq_fine_op1"))->get_value();
	send_midi();
	LOG_OUT();
};

void SysexEdit::on_dtun_op1_event() {	LOG_IN();
	msg[3]=0x00;
	msg[4]=0x7D;
    msg[5]=(get_gwidget<Gtk::HScale>("dtun_op1"))->get_value()+7;
	send_midi();
	LOG_OUT();
};

/* op1 eg*/
void SysexEdit::on_eg_rt1_op1_event() {	LOG_IN();
	msg[3]=0x00;
	msg[4]=0x69;
	msg[5]=(get_gwidget<Gtk::SpinButton>("eg_rt1_op1"))->get_value();
	send_midi();
	LOG_OUT();
};

void SysexEdit::on_eg_rt2_op1_event() {	LOG_IN();
	msg[3]=0x00;
	msg[4]=0x6A;
	msg[5]=(get_gwidget<Gtk::SpinButton>("eg_rt2_op1"))->get_value();
	send_midi();
	LOG_OUT();
};

void SysexEdit::on_eg_rt3_op1_event() {	LOG_IN();
	msg[3]=0x00;
	msg[4]=0x6B;
	msg[5]=(get_gwidget<Gtk::SpinButton>("eg_rt3_op1"))->get_value();
	send_midi();
	LOG_OUT();
};

void SysexEdit::on_eg_rt4_op1_event() {	LOG_IN();
	msg[3]=0x00;
	msg[4]=0x6C;
	msg[5]=(get_gwidget<Gtk::SpinButton>("eg_rt4_op1"))->get_value();
	send_midi();
	LOG_OUT();
};

void SysexEdit::on_eg_lvl1_op1_event() {	LOG_IN();
	msg[3]=0x00;
	msg[4]=0x6D;
	msg[5]=(get_gwidget<Gtk::SpinButton>("eg_lvl1_op1"))->get_value();
	send_midi();
	LOG_OUT();
};

void SysexEdit::on_eg_lvl2_op1_event() {	LOG_IN();
	msg[3]=0x00;
	msg[4]=0x6E;
	msg[5]=(get_gwidget<Gtk::SpinButton>("eg_lvl2_op1"))->get_value();
	send_midi();
	LOG_OUT();
};

void SysexEdit::on_eg_lvl3_op1_event() {	LOG_IN();
	msg[3]=0x00;
	msg[4]=0x6F;
	msg[5]=(get_gwidget<Gtk::SpinButton>("eg_lvl3_op1"))->get_value();
	send_midi();
	LOG_OUT();
};

void SysexEdit::on_eg_lvl4_op1_event() {	LOG_IN();
	msg[3]=0x00;
	msg[4]=0x70;
	msg[5]=(get_gwidget<Gtk::SpinButton>("eg_lvl4_op1"))->get_value();
	send_midi();
	LOG_OUT();
};


/* OP1 frame volume*/

void SysexEdit::on_krs_op1_event() {	LOG_IN();
	msg[3]=0x00;
	msg[4]=0x76;
	msg[5]=(get_gwidget<Gtk::HScale>("krs_op1"))->get_value();
	send_midi();
	LOG_OUT();
};

void SysexEdit::on_kvs_op1_event() {	LOG_IN();
	msg[3]=0x00;
	msg[4]=0x78;
	msg[5]=(get_gwidget<Gtk::HScale>("kvs_op1"))->get_value();
	send_midi();
	LOG_OUT();
};

void SysexEdit::on_lvl_op1_event() {	LOG_IN();
	msg[3]=0x00;
	msg[4]=0x79;
	msg[5]=(get_gwidget<Gtk::SpinButton>("lvl_op1"))->get_value();
	send_midi();
	LOG_OUT();
};

void SysexEdit::on_mute_op1_event() {	LOG_IN();
	if ( (get_gwidget<Gtk::ToggleButton>("mute_op1"))->get_active() ) {
		(get_gwidget<Gtk::Label>("label_general_op1"))->set_label(_("<b><s>Operateur 1</s></b>"));	
	}else{
		(get_gwidget<Gtk::Label>("label_general_op1"))->set_label(_("<b>Operateur 1</b>"));
	};
	LOG_OUT();
};

/* function for loader */
extern "C" {
	Glib::RefPtr<Gtk::Builder> LoadPlug(Glib::ustring name, guint index){	
		SysexEdit * editor;
		editor = new SysexEdit(name,index);
		return editor->get_refxml();
	};	
}

SysexEdit::SysexEdit(Glib::ustring name, guint index) : Gemod(name,index) {
	/*basic constructor */
	LOG_IN();
	#ifdef ENABLE_NLS
		setlocale (LC_ALL, "");
		bindtextdomain (GETTEXT_PACKAGE, PROGRAMNAME_LOCALEDIR);
		bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
		textdomain (GETTEXT_PACKAGE);
	#endif
	/* I/O init */
	Gio::init();
	m_refListStore = Glib::RefPtr<Gtk::ListStore>::cast_dynamic(get_gobject("liststore_bank"));
	attach_signals();
	connect_midi();
	/* start thread */
	S_Thread();
	LOG_OUT();
};

SysexEdit::~SysexEdit(){ LOG_IN(); 
	/* basic destructor*/
	/* terminate thread */
	T_Thread();
	deconnect_midi();
	LOG_OUT(); 
};

bool SysexEdit::Run(){ LOG_IN(); 
	/* Thread function */
	listen_midi();
	LOG_OUT(); 
	return TRUE;
};

void SysexEdit::connect_midi(){
	LOG_IN();
	/* 0 can be replace by SND_SEQ_NONBLOCK */
	snd_seq_open(&seq_handle, "default", SND_SEQ_OPEN_DUPLEX, 0);
	snd_seq_set_client_name(seq_handle, "GxSynth");
	//snd_seq_create_port(seq_handle, 0);
    port_in =	snd_seq_create_simple_port(seq_handle, "GxSynth",
				SND_SEQ_PORT_CAP_WRITE|SND_SEQ_PORT_CAP_SUBS_WRITE,
				SND_SEQ_PORT_TYPE_APPLICATION);
	port_out =	snd_seq_create_simple_port(seq_handle, "GxSynth",
				SND_SEQ_PORT_CAP_READ|SND_SEQ_PORT_CAP_SUBS_READ,
				SND_SEQ_PORT_TYPE_APPLICATION);	
	//snd_seq_set_input_buffer_size(seq_handle,in_buff_size) ;	
	//snd_seq_set_output_buffer_size(seq_handle,out_buff_size) ;
	//snd_seq_system_info(seq_handle,info);		
	/* polling */
	/* size of poll descriptors */
	spfd = snd_seq_poll_descriptors_count(seq_handle, POLLIN|POLLOUT);
	/* array of poll descriptors */
	pfd = (struct pollfd *)alloca(spfd * sizeof(struct pollfd));
	/* Get poll descriptors. */
	snd_seq_poll_descriptors(seq_handle, pfd, spfd, POLLIN|POLLOUT);
	LOG_OUT();
};

void SysexEdit::deconnect_midi(){
	LOG_IN();
		snd_seq_close(seq_handle);
	LOG_OUT();
};

void SysexEdit::listen_midi(){
    snd_seq_event_input(seq_handle, &ev);
	std::cout << "data type : " << ev->type << std::endl;
	std::cout << "data flags : " << ev->flags << std::endl;
	std::cout << "data tag : " << ev->tag << std::endl;
	std::cout << "data queue : " << ev->queue << std::endl;
	/*std::cout << "data tics : " << ev->time.tick << ", time" << (char*)ev->time.time.tv_sec << std::endl;
	std::cout << "data source : " << (char*)ev->source.client << std::endl;
	std::cout << "data dest : " << (char*)ev->dest.client << std::endl;*/
	
    switch (ev->type) {
		case SND_SEQ_EVENT_CONTROLLER: 
			std::cout << "Control event on Channel : "
				<< ev->data.control.channel
				<< ", param : "  << ev->data.control.param << " , value : " 
				<<	std::hex << ev->data.control.value 
			<< std::endl;
			break;
		case SND_SEQ_EVENT_PITCHBEND:
			std::cout << "Pitchbender event on Channel : " << std::dec << ev->data.control.channel << ", " << std::hex << ev->data.control.value << std::endl;
			break;
		case SND_SEQ_EVENT_NOTEON:
			std::cout <<  "Note On event on Channel : "  << ev->data.control.channel << ", " << std::dec << ev->data.note.note << std::endl;;
			break;        
		case SND_SEQ_EVENT_NOTEOFF: 
			std::cout <<  "Note Off event on Channel : "  <<  ev->data.control.channel << ", " << std::hex << ev->data.note.note << std::endl;      
			break;   
		/*case SND_SEQ_EVENT_SYSTEM :
			system status; event data type = snd_seq_result_t
SND_SEQ_EVENT_RESULT 	returned result status; event data type = snd_seq_result_t
SND_SEQ_EVENT_NOTE 	note on and off with duration; event data type = snd_seq_ev_note_t
SND_SEQ_EVENT_NOTEON 	note on; event data type = snd_seq_ev_note_t
SND_SEQ_EVENT_NOTEOFF 	note off; event data type = snd_seq_ev_note_t
SND_SEQ_EVENT_KEYPRESS 	key pressure change (aftertouch); event data type = snd_seq_ev_note_t
SND_SEQ_EVENT_CONTROLLER 	controller; event data type = snd_seq_ev_ctrl_t
SND_SEQ_EVENT_PGMCHANGE 	program change; event data type = snd_seq_ev_ctrl_t
SND_SEQ_EVENT_CHANPRESS 	channel pressure; event data type = snd_seq_ev_ctrl_t
SND_SEQ_EVENT_PITCHBEND 	pitchwheel; event data type = snd_seq_ev_ctrl_t; data is from -8192 to 8191)
SND_SEQ_EVENT_CONTROL14 	14 bit controller value; event data type = snd_seq_ev_ctrl_t
SND_SEQ_EVENT_NONREGPARAM 	14 bit NRPN; event data type = snd_seq_ev_ctrl_t
SND_SEQ_EVENT_REGPARAM 	14 bit RPN; event data type = snd_seq_ev_ctrl_t
SND_SEQ_EVENT_SONGPOS 	SPP with LSB and MSB values; event data type = snd_seq_ev_ctrl_t
SND_SEQ_EVENT_SONGSEL 	Song Select with song ID number; event data type = snd_seq_ev_ctrl_t
SND_SEQ_EVENT_QFRAME 	midi time code quarter frame; event data type = snd_seq_ev_ctrl_t
SND_SEQ_EVENT_TIMESIGN 	SMF Time Signature event; event data type = snd_seq_ev_ctrl_t
SND_SEQ_EVENT_KEYSIGN 	SMF Key Signature event; event data type = snd_seq_ev_ctrl_t
SND_SEQ_EVENT_START 	MIDI Real Time Start message; event data type = snd_seq_ev_queue_control_t
SND_SEQ_EVENT_CONTINUE 	MIDI Real Time Continue message; event data type = snd_seq_ev_queue_control_t
SND_SEQ_EVENT_STOP 	MIDI Real Time Stop message; event data type = snd_seq_ev_queue_control_t
SND_SEQ_EVENT_SETPOS_TICK 	Set tick queue position; event data type = snd_seq_ev_queue_control_t
SND_SEQ_EVENT_SETPOS_TIME 	Set real-time queue position; event data type = snd_seq_ev_queue_control_t
SND_SEQ_EVENT_TEMPO 	(SMF) Tempo event; event data type = snd_seq_ev_queue_control_t
SND_SEQ_EVENT_CLOCK 	MIDI Real Time Clock message; event data type = snd_seq_ev_queue_control_t
SND_SEQ_EVENT_TICK 	MIDI Real Time Tick message; event data type = snd_seq_ev_queue_control_t
SND_SEQ_EVENT_QUEUE_SKEW 	Queue timer skew; event data type = snd_seq_ev_queue_control_t
SND_SEQ_EVENT_SYNC_POS 	Sync position changed; event data type = snd_seq_ev_queue_control_t
SND_SEQ_EVENT_TUNE_REQUEST 	Tune request; event data type = none
SND_SEQ_EVENT_RESET 	Reset to power-on state; event data type = none
SND_SEQ_EVENT_SENSING 	Active sensing event; event data type = none
SND_SEQ_EVENT_ECHO 	Echo-back event; event data type = any type
SND_SEQ_EVENT_OSS 	OSS emulation raw event; event data type = any type
SND_SEQ_EVENT_CLIENT_START 	New client has connected; event data type = snd_seq_addr_t
SND_SEQ_EVENT_CLIENT_EXIT 	Client has left the system; event data type = snd_seq_addr_t
SND_SEQ_EVENT_CLIENT_CHANGE 	Client status/info has changed; event data type = snd_seq_addr_t
SND_SEQ_EVENT_PORT_START 	New port was created; event data type = snd_seq_addr_t
SND_SEQ_EVENT_PORT_EXIT 	Port was deleted from system; event data type = snd_seq_addr_t
SND_SEQ_EVENT_PORT_CHANGE 	Port status/info has changed; event data type = snd_seq_addr_t
SND_SEQ_EVENT_PORT_SUBSCRIBED 	Ports connected; event data type = snd_seq_connect_t
SND_SEQ_EVENT_PORT_UNSUBSCRIBED 	Ports disconnected; event data type = snd_seq_connect_t
SND_SEQ_EVENT_USR0 	user-defined event; event data type = any (fixed size)
SND_SEQ_EVENT_USR1 	user-defined event; event data type = any (fixed size)
SND_SEQ_EVENT_USR2 	user-defined event; event data type = any (fixed size)
SND_SEQ_EVENT_USR3 	user-defined event; event data type = any (fixed size)
SND_SEQ_EVENT_USR4 	user-defined event; event data type = any (fixed size)
SND_SEQ_EVENT_USR5 	user-defined event; event data type = any (fixed size)
SND_SEQ_EVENT_USR6 	user-defined event; event data type = any (fixed size)
SND_SEQ_EVENT_USR7 	user-defined event; event data type = any (fixed size)
SND_SEQ_EVENT_USR8 	user-defined event; event data type = any (fixed size)
SND_SEQ_EVENT_USR9 	user-defined event; event data type = any (fixed size)
SND_SEQ_EVENT_SYSEX 	system exclusive data (variable length); event data type = snd_seq_ev_ext_t
SND_SEQ_EVENT_BOUNCE 	error event; event data type = snd_seq_ev_ext_t
SND_SEQ_EVENT_USR_VAR0 	reserved for user apps; event data type = snd_seq_ev_ext_t
SND_SEQ_EVENT_USR_VAR1 	reserved for user apps; event data type = snd_seq_ev_ext_t
SND_SEQ_EVENT_USR_VAR2 	reserved for user apps; event data type = snd_seq_ev_ext_t
SND_SEQ_EVENT_USR_VAR3 	reserved for user apps; event data type = snd_seq_ev_ext_t
SND_SEQ_EVENT_USR_VAR4 	reserved for user apps; event data type = snd_seq_ev_ext_t
SND_SEQ_EVENT_NONE 	NOP; ignored in any case */
    };
    snd_seq_free_event(ev);
};

void SysexEdit::send_midi(){
	LOG_IN();
	/* TODO; use seq queue */
	/*Parameter Change s=1 g=0
	 11110000  F0   Status byte - start sysex
     0iiiiiii  43   ID # (i=67; Yamaha)
     0sssnnnn  10   Sub-status (s=1) & channel number (n=0; ch 1)
     0gggggpp  **   parameter group # (g=0; single voice, g=2; function)
     0ppppppp  **   parameter # (these are listed in next section)
                     Note that voice parameter #'s can go over 128 so
                     the pp bits in the group byte are either 00 for
                     par# 0-127 or 01 for par# 128-155. In the latter case
                     you add 128 to the 0ppppppp byte to compute par#. 
     0ddddddd  **   data byte
     11110111  F7   Status - end sysex
	*/
	msg[0]=0xF0;
	msg[1]=id_fabricant;
	msg[2]=sub_status & channel;
	msg[6]=0xF7;
	
//#ifdef USE_ALSA_MIDI	
	/* seq event */
	snd_seq_event_t ev_out;
    snd_seq_ev_clear(&ev_out);
    snd_seq_ev_set_source(&ev_out, port_out);
	snd_seq_ev_set_subs(&ev_out);
	/* */
	snd_seq_ev_set_direct(&ev_out);

    ev_out.type = SND_SEQ_EVENT_SYSEX;
	
    snd_seq_ev_set_variable(&ev_out, sysex_size, msg);
	snd_seq_event_output(seq_handle, &ev_out);
	snd_seq_drain_output(seq_handle);
//#else
//#enddef
	LOG_OUT();
}

/* load raw bank file */
void SysexEdit::load_raw_bank(Glib::RefPtr<Gio::File> bank_file){
	/* open file */
	try {
		/*TODO TEST EXTENTIon*/
		/*if extention == dx7 */
		data_stream = Gio::DataInputStream::create(bank_file->read());
		switch ( (bank_file->query_info(G_FILE_ATTRIBUTE_STANDARD_SIZE))->get_size() ){
			case 128:
				/* one voices bulk */
	/* s=0 f=0
    0sssnnnn  00   Sub-status (s=0) & channel number (n=0; ch 1)
    0fffffff  00   format number (f=0; 1 voice)
    0bbbbbbb  01   byte count MS byte
    0bbbbbbb  1B   byte count LS byte (b=155; 1 voice)
	0ddddddd  **   data byte 1
	0ddddddd  **   data byte 155
	0eeeeeee  **   checksum (masked 2's complement of sum of 155 bytes)
	*/
				seek_voice(0, &bank_1_origin.sound[0]);
				bank_1_modif=bank_1_origin;
				break;
			case 4096:
				/* 32 voices bulk */
	/* s=0 f=9 b=4096
    0sssnnnn  00   Sub-status (s=0) & channel number (n=0; ch 1)
    0fffffff  09   format number (f=9; 32 voices)
    0bbbbbbb  20   byte count MS byte
    0bbbbbbb  00   byte count LS byte (b=4096; 32 voices)
    0ddddddd  **   data byte 1
    0ddddddd  **   data byte 4096  (there are 128 bytes / voice)
    0eeeeeee  **   checksum (masked 2's comp. of sum of 4096 bytes)
		*/
				for( guint8 i = 0; i < 32; i++ ){
					seek_voice(i,&bank_32_origin.sound[i]);
				};
				bank_32_modif=bank_32_origin;
				break;
			case 16384:
				/* 128 voices */
			
				for( guint8 i = 0; i < 128; i++ ){
					seek_voice(i, &bank_128_origin.sound[i]);
				};
				bank_128_modif=bank_128_origin;
				break;	
		};
		data_stream->close();

		
		//set_voice(0);
		(get_gwidget<Gtk::TreeView>("treeview_bank"))->set_cursor( m_refListStore->get_path(m_refListStore->get_iter("0:0")) );
	}catch(const Glib::Exception& ex){
		std::cerr << "Exception caught: " << ex.what() << std::endl;
	};
};

void SysexEdit::seek_voice(guint i, St_dx7sysex_1* sound){
	guint8 byte_read;
	guint8 val;
	/* operator j */
	for ( guint8 j = 6; j-- != 0 ; ){
		/* OP[J] EG RATE[k] */
		for ( guint8 k = 0; k < 4 ; k++ ){
			sound->op[j].eg_rt[k].val=data_stream->read_byte();
		};
		/* OP[J] EG LVL[k] */
		for ( guint8 k = 0; k < 4 ; k++  ){
			sound->op[j].eg_lvl[k].val=data_stream->read_byte();
		};
		sound->op[j].kls.brk_pt.val=data_stream->read_byte();
		sound->op[j].kls.lft_dpth.val=data_stream->read_byte();
		sound->op[j].kls.rght_dpth.val=data_stream->read_byte();
		/* set out first 4 unused bit by mask (addr bit 11)*/
		val=data_stream->read_byte() & 0x0F ;
		/* first two bit to rc and last two bit to lc*/
		sound->op[j].kls.rght_curve.val=val >> 2;
		sound->op[j].kls.lft_curve.val=val & 3 ;
		/* set out first 1 unused bit by mask  (addr bit 12)*/
		val=data_stream->read_byte() & 0x7F;
		sound->op[j].dtun.val=val >> 3 ;
		sound->op[j].krs.val=val & 7;
		/* set out first 3 unused bit by mask  (addr bit 13)*/
		val=data_stream->read_byte() & 0x1F;
		sound->op[j].kvs.val=val >> 2;
		sound->op[j].ams.val=val & 3;
		sound->op[j].lvl.val=data_stream->read_byte();
		/* set out first 2 unused bit by mask  (addr bit 15)*/
		val=data_stream->read_byte() & 0x3F;
		sound->op[j].freq_coarse.val=val >> 1;
		sound->op[j].freq_mode.val=val & 1;
		sound->op[j].freq_fine.val=data_stream->read_byte();	
	};
	for(guint8 j=0 ; j <= 3; j++ ){
		sound->pitch.rt[j].val=data_stream->read_byte();
	};
	for(guint8 j=0 ; j <= 3; j++ ){
		sound->pitch.lvl[j].val=data_stream->read_byte();
	};
	sound->algo.algo.val=data_stream->read_byte() & 0x1F ;
	/* set out first 2 unused bit by mask  (addr bit 111)*/
	val=data_stream->read_byte() & 0x0F;
	sound->algo.oks.val=val >> 3;
	sound->algo.feedback.val=val & 7;
	sound->lfo.speed.val=data_stream->read_byte();
	sound->lfo.delay.val=data_stream->read_byte();
	sound->lfo.pmd.val=data_stream->read_byte();
	sound->lfo.amd.val=data_stream->read_byte();
	/* (addr bit 116) */
	val=data_stream->read_byte();
	sound->lfo.pms.val=val >> 4;
	sound->lfo.wave.val=(val >> 1) & 0x07;
	sound->lfo.sync.val=val & 1;
	sound->algo.transpose.val=data_stream->read_byte();
	
	Glib::ustring name;
	std::ostringstream strm;
	for(guint8 j=0; j <= 9;j++){
		strm << data_stream->read_byte();
	};
	name=strm.str();
	sound->name=name.c_str();
	/* add voice name to treeview */
	/* create row */
	Gtk::TreeIter iter = m_refListStore->append();
    Gtk::TreeModel::Row row = *(iter);
	/* C++ version*/
    /*
	row->set_value(1,sound->name);
    row->set_value(0, i+1); 
	*/
	
	/* C version working*/
   	gtk_list_store_set(m_refListStore->gobj(), iter.gobj(), 0, i+1, 1,sound->name, -1);
};


void SysexEdit::on_treeview_row_activated(const Gtk::TreeModel::Path& path,
        Gtk::TreeViewColumn* /* column */){
  Gtk::TreeModel::iterator iter = m_refListStore->get_iter(path);
  if(iter){
    Gtk::TreeModel::Row row = *iter;
	guint num;
	Glib::ustring name;
	row->get_value(0,num);
	row->get_value(1,name);
    std::cout << "Row activated: ID=" << num
		      << ", Name="            << name << std::endl;
  };
};

void SysexEdit::on_treeview_row_clicked(){
	Gtk::TreeModel::Path path;
	Gtk::TreeViewColumn* col;
	(get_gwidget<Gtk::TreeView>("treeview_bank"))->get_cursor(path,col);
	Gtk::TreeModel::iterator iter = m_refListStore->get_iter(path);
	if(iter){
		Gtk::TreeModel::Row row = *iter;
		guint num;
		guint nb_elmnt=0;	
		row->get_value(0,num);
		Gtk::TreeModel::Children::iterator iter_child = m_refListStore->children().begin();
		for( ; iter_child != m_refListStore->children().end(); ++iter_child){
			nb_elmnt++;
		};
		
		switch ( nb_elmnt ){
			case 1:
				set_voice(&bank_1_modif.sound[num-1]);
				break;
			case 32:
				set_voice(&bank_32_modif.sound[num-1]);
				break;
			case 128:
				set_voice(&bank_128_modif.sound[num-1]);
				break;
		};
	};
};
void SysexEdit::clean_bank(){
	m_refListStore->clear();
};

void SysexEdit::on_bank_select(){
	/* if (modif done)
		ask save
	*/
	clean_bank();
	/* switch((get_gwidget<Gtk::FileChooserButton>("bank_select"))->get_filename()) {
			case "sys":
				break;
			case "raw":
				break;
			case "dx7":
				break;
	};*/
	load_raw_bank((get_gwidget<Gtk::FileChooserButton>("bank_select"))->get_file());
};
	//std::cout << std::hex << msg << std::endl;
#endif /* dxinterface_H */
